// From the software distribution accompanying the textbook
// "A Practical Introduction to Data Structures and Algorithm Analysis,
// Third Edition (C++)" by Clifford A. Shaffer.
// Source code Copyright (C) 2007-2011 by Clifford A. Shaffer.

// Test program for checking syntax of a hash table-based dictionary

#include "book.h"
#include "hashdict.h"

int main()
{
    // Hash table with int keys and values as pointers to int
    hashdict<int, int *> intDict(1000, -1, -2);

    intDict.insert(10, new int(10));
    intDict.insert(11, new int(20));
    
    int *val;
    if((val = intDict.find(10)) != nullptr)
        cout << "Found value " << *val << " to match key value 10" << endl;
    else
        cout << "Nothing found to match key value 10" << endl;

    if((val = intDict.find(13)) != nullptr)
        cout << "Found value " << *val << " to match key value 13" << endl;
    else
        cout << "Nothing found to match key value 10" << endl;

    if((val = intDict.remove(10)) != nullptr)
        cout << "Remove value " << *val << " to match key value 10" << endl;
    else
        cout << "Nothing found to match key value 10" << endl;

    if((val = intDict.remove(10)) != nullptr)
        cout << "Remove value " << *val << " to match key value 10" << endl;
    else
        cout << "Nothing found to match key value 10" << endl;

// Hash table with int keys and values as pointers to char
    hashdict<char *, char *> strDict(1000, "", "TOMB");

    strDict.insert("Name2", "Address2");
    //strDict.remove("Name3000");

    char *str;
    if((str = strDict.find("Name2")) != nullptr)
        cout << "Found value " << str << " to match key value Name2" << endl;
    else
        cout << "Nothing found to match key value hello" << endl;
    
    if((str = strDict.remove("Name2")) != nullptr)
        cout << "Found value " << str << " to match key value Name2" << endl;
    else
        cout << "Nothing found to match key value hello" << endl;


    return 0;
}

